﻿using MySql.Data.MySqlClient;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PoEcoDB.DB
{
    internal class User
    {
        public static MySqlConnection MxPoEDB()
        {
            MySqlConnection conn;
            string myConnectionString;

            myConnectionString = $"server={JSON.Settings.GetdbHost()};port={JSON.Settings.GetdbPort()};uid={JSON.Settings.GetdbUser()};pwd={JSON.Settings.GetdbPass()};database={JSON.Settings.GetdbName()};";
            conn = new MySqlConnection();
            conn.ConnectionString = myConnectionString;
            return conn;
        }

        public static bool CheckUserExists(string user)
        {
            MySqlConnection con = MxPoEDB();
            string cmdText = $"SELECT * FROM poeco_user WHERE account = '{user}'";
            MySqlCommand cmd = new MySqlCommand(cmdText, con);
            con.Open();
            var row = cmd.ExecuteReader();
            if (row.HasRows) { con.Close(); return true; } else { con.Close(); return false; }            
        }

        public static int GetUserID(string user)
        {
            using (var con = MxPoEDB())
            {
                string cmdText = $"SELECT * FROM poeco_user WHERE account = '{user}'";
                MySqlCommand cmd = new MySqlCommand(cmdText, con);
                con.Open();
                var row = cmd.ExecuteReader();
                if (row.HasRows) { row.Read(); return Convert.ToInt32(row["uid"]); } else { return 0; }
            }
        }

        public static int GetUserTabIndex(string user)
        {
            MySqlConnection con = MxPoEDB();
            string cmdText = $"SELECT * FROM poeco_user WHERE account = '{user}'";
            MySqlCommand cmd = new MySqlCommand(cmdText, con);
            con.Open();
            var row = cmd.ExecuteReader();
            if (row.HasRows) { row.Read(); return Convert.ToInt32(row["tabindex"]); } else { return 0; }
        }

        public static int GetUserCurrencyIndex(string user, string column)
        {
            MySqlConnection con = MxPoEDB();
            string cmdText = $"SELECT * FROM poeco_user WHERE account = '{user}'";
            MySqlCommand cmd = new MySqlCommand(cmdText, con);
            con.Open();
            var row = cmd.ExecuteReader();
            if (row.HasRows) { row.Read(); return Convert.ToInt32(row[column]); } else { return 0; }
        }

        public static int GetUserItemCount(string user)
        {
            MySqlConnection con = MxPoEDB();
            string cmdText = $"SELECT * FROM poeco_user WHERE account = '{user}'";
            MySqlCommand cmd = new MySqlCommand(cmdText, con);
            con.Open();
            var row = cmd.ExecuteReader();
            if (row.HasRows) { row.Read(); return Convert.ToInt32(row["itemcount"]); } else { return 0; }
        }

        public static string GetUserStashHash(string user)
        {
            MySqlConnection con = MxPoEDB();
            string cmdText = $"SELECT * FROM poeco_user WHERE account = '{user}'";
            MySqlCommand cmd = new MySqlCommand(cmdText, con);
            con.Open();
            var row = cmd.ExecuteReader();
            if (row.HasRows) { row.Read(); return row["stashb64"].ToString(); } else { return ""; }
        }

        public static string GetUserToken(string user)
        {
            MySqlConnection con = MxPoEDB();
            string cmdText = $"SELECT * FROM poeco_user WHERE account = '{user}'";
            MySqlCommand cmd = new MySqlCommand(cmdText, con);
            con.Open();
            var row = cmd.ExecuteReader();
            if (row.HasRows) { row.Read(); return row["token"].ToString(); } else { return ""; }
        }

        public static void SetUserItemCount(string user, int count)
        {
            MySqlConnection con = MxPoEDB();
            string cmdText = $"UPDATE poeco_user SET itemcount = '{count}' WHERE account = '{user}'";
            MySqlCommand cmd = new MySqlCommand(cmdText, con);
            con.Open();
            cmd.ExecuteNonQuery();
            con.Close();
        }

        public static void SetUserStashHash(string user, string b64)
        {
            MySqlConnection con = MxPoEDB();
            string cmdText = $"UPDATE poeco_user SET stashb64 = '{b64}' WHERE account = '{user}'";
            MySqlCommand cmd = new MySqlCommand(cmdText, con);
            con.Open();
            cmd.ExecuteNonQuery();
            con.Close();
        }

        public static void SetUserTabValue(string user, double value)
        {
            MySqlConnection con = MxPoEDB();
            string cmdText = $"UPDATE poeco_user SET tabvalue = '{value}' WHERE account = '{user}'";
            MySqlCommand cmd = new MySqlCommand(cmdText, con);
            con.Open();
            cmd.ExecuteNonQuery();
            con.Close();
        }
    }
}
