﻿using MySql.Data.MySqlClient;
using Newtonsoft.Json;
using PoEcoDB.DB;
using System;
using System.Collections.Generic;
using System.Diagnostics.Metrics;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using static PoEcoDB.JSON.Stash;

namespace PoEcoDB.JSON
{
    internal class Currency
    {
        public static MySqlConnection MxPoEDB()
        {
            MySqlConnection conn;
            string myConnectionString;

            myConnectionString = $"server={JSON.Settings.GetdbHost()};port={JSON.Settings.GetdbPort()};uid={JSON.Settings.GetdbUser()};pwd={JSON.Settings.GetdbPass()};database={JSON.Settings.GetdbName()};";
            conn = new MySqlConnection();
            conn.ConnectionString = myConnectionString;
            return conn;
        }
        public static void GenCurrencyTab(string user, int tab, string columnname, string table)
        {
            int uid = DB.User.GetUserID(user);
            double chaosValue = 0;
            string curName = "";
            StashRoot stash = JsonConvert.DeserializeObject<StashRoot>(File.ReadAllText($@"data/stash/{user}.tab.{tab.ToString()}.json"));
            foreach (Item i in stash.items)
            {
                curName = i.typeLine;
                chaosValue = chaosValue + (GetCurrencyValueByName(MySqlHelper.EscapeString(curName),table) * i.stackSize);
            }
            Message.CMW(chaosValue.ToString(),true,2);
            MySqlConnection con = MxPoEDB();
            string cmdText = $"UPDATE poeco_user SET {columnname} = '{chaosValue}' WHERE account = '{user}'";
            MySqlCommand cmd = new MySqlCommand(cmdText, con);
            con.Open();
            cmd.ExecuteNonQuery();
            con.Close();
        }
        public static int GetCurrencyValueByName(string name, string table)
        {
            using (var con = MxPoEDB())
            {
                string cmdText = $"SELECT * FROM {table} WHERE name = '{name}'";
                MySqlCommand cmd = new MySqlCommand(cmdText, con);
                con.Open();
                var row = cmd.ExecuteReader();
                if (row.HasRows) { row.Read(); return Convert.ToInt32(row["vchaos"]); } else { return 0; }
            }
        }
    }
}
